Nie możesz wybrać więcej, niż 25 tematów Tematy muszą się zaczynać od litery lub cyfry, mogą zawierać myślniki ('-') i mogą mieć do 35 znaków.

100 wiersze
3.8 KiB

  1. #!/usr/bin/env zsh
  2. # -------------------------------------------------------------------------------------------------
  3. # Copyright (c) 2010-2015 zsh-syntax-highlighting contributors
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without modification, are permitted
  7. # provided that the following conditions are met:
  8. #
  9. # * Redistributions of source code must retain the above copyright notice, this list of conditions
  10. # and the following disclaimer.
  11. # * Redistributions in binary form must reproduce the above copyright notice, this list of
  12. # conditions and the following disclaimer in the documentation and/or other materials provided
  13. # with the distribution.
  14. # * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
  15. # may be used to endorse or promote products derived from this software without specific prior
  16. # written permission.
  17. #
  18. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
  19. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  20. # FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
  21. # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  22. # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  23. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  24. # IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  25. # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  26. # -------------------------------------------------------------------------------------------------
  27. # -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
  28. # vim: ft=zsh sw=2 ts=2 et
  29. # -------------------------------------------------------------------------------------------------
  30. # Check an highlighter was given as argument.
  31. [[ -n "$1" ]] || {
  32. echo >&2 "Bail out! You must provide the name of a valid highlighter as argument."
  33. exit 2
  34. }
  35. # Check the highlighter is valid.
  36. [[ -f ${0:h:h}/highlighters/$1/$1-highlighter.zsh ]] || {
  37. echo >&2 "Bail out! Could not find highlighter ${(qq)1}."
  38. exit 2
  39. }
  40. # Check the highlighter has test data.
  41. [[ -d ${0:h:h}/highlighters/$1/test-data ]] || {
  42. echo >&2 "Bail out! Highlighter ${(qq)1} has no test data."
  43. exit 2
  44. }
  45. # Load the main script.
  46. . ${0:h:h}/zsh-syntax-highlighting.zsh
  47. # Activate the highlighter.
  48. ZSH_HIGHLIGHT_HIGHLIGHTERS=($1)
  49. # Runs a highlighting test
  50. # $1: data file
  51. run_test_internal() {
  52. local -a highlight_zone
  53. local tests_tempdir="$1"; shift
  54. local srcdir="$PWD"
  55. builtin cd -q -- "$tests_tempdir" || { echo >&2 "Bail out! cd failed: $?"; return 1 }
  56. echo -n "# ${1:t:r}: "
  57. # Load the data and prepare checking it.
  58. PREBUFFER= BUFFER= ;
  59. . "$srcdir"/"$1"
  60. # Check the data declares $PREBUFFER or $BUFFER.
  61. [[ -z $PREBUFFER && -z $BUFFER ]] && { echo >&2 "Bail out! Either 'PREBUFFER' or 'BUFFER' must be declared and non-blank"; return 1; }
  62. # Measure the time taken by _zsh_highlight.
  63. TIMEFMT="%*Es"
  64. time (BUFFER="$BUFFER" && _zsh_highlight)
  65. }
  66. run_test() {
  67. # Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
  68. local __tests_tempdir
  69. __tests_tempdir="$(mktemp -d)" && [[ -d $__tests_tempdir ]] || {
  70. echo >&2 "Bail out! mktemp failed"; return 1
  71. }
  72. typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
  73. {
  74. (run_test_internal "$__tests_tempdir" "$@")
  75. } always {
  76. rm -rf -- "$__tests_tempdir"
  77. }
  78. }
  79. # Process each test data file in test data directory.
  80. for data_file in ${0:h:h}/highlighters/$1/test-data/*.zsh; do
  81. run_test "$data_file"
  82. (( $pipestatus[1] )) && exit 2
  83. done
  84. exit 0